
struct bucket
{
	struct bucket * next;
	struct bucketinfo * parent;
	
	double bucket;
};

struct entry
{
	struct policy * policy;
	struct entry * next;
	int id;
	struct sockaddr_in ip;
	
	char *aaddr;
	char *label;
	
	double sum;
	int accounted;
	
	int sent;
	int recv;
	struct timeval tv[BACKLOG];
	struct timeval last_sent;
	unsigned short lastid;
	
	struct bucket * buckets;
};

struct bucketinfo
{
	struct bucketinfo *next;
	double limit;
	double span;
	double threshold;
	char *name;
};

struct policy 
{
	struct policy * next;
	char *id;
	double freq;
	struct bucketinfo *buckets;
};

struct pinginfo
{
	struct timeval tv;
	int id;
};


struct context
{
	char *filename;
	int skt;
	int pid;
	int size;
	
	struct policy *policies;
	struct entry *hosts;
	Hash * ip_hash;
	Hash * label_hash;
	double freq;
	double pps;
	int verbose;
	
	struct entry *current;
};

struct context * cfg_read(char *filename);
void send_pings(int sig);
void recv_pings(struct context * ctx);
