
#define CSS_MAXVALUE 1024
#define CSS_HASHSIZE 31

struct cssval
{
	struct cssval * next;
	char *name;
	char *value;
};


struct cssctx
{
	struct cssctx * next;
	char *name;
	
	struct cssctx * children[CSS_HASHSIZE];
	struct cssval * values[CSS_HASHSIZE];
};

typedef struct cssctx cssctx;
typedef struct cssval cssval;

char * css_LoadFile(const char * name, int *lenstore, int err);
cssctx * css_Parse(char * data, int len, char *errbuf, int errlen);
cssctx * css_ParseFile(const char * file, char *errbuf, int errlen);
cssval * css_FindValue(cssctx * ctx, cssval * prev, char *name);
cssctx * css_FindChild(cssctx * ctx, cssctx * prev, char *name);
int css_IsTrue(cssctx * ctx, char * name, int def);
int css_TrueString(char *str);

