#ifdef MEMDEBUG
#ifndef DEBUG
#define DEBUG
#endif
#endif

#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <stdio.h>
#include "debug.h"
#include "memory.h"

void * mem_alloc(char *name, int size)
{
	void *v;
	assert(v = malloc(size));
	memset(v, 0, size);
	debug("[memory] alloc %p size %d purpose %s\n", v, size, name);
	return(v);
}

void mem_free(void *s)
{
	free(s);
	if(s)
		debug("[memory] free %p\n", s);
}

void * mem_realloc(char *name, void *block, int size)
{
	void *v;
	assert(v = realloc(block, size));
	debug("[memory] realloc %p to %p size %d purpose %s\n", block, v, size, name);
	return(v);
}

void * mem_strdup(char *name, char *string)
{
	char *v;
	assert(v = strdup(string));
	debug("[memory] strdup %p purpose %s\n", v, name);
	return(v);
}
